package com.example;

import java.util.ArrayList;

import javax.ws.rs.core.Response;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.spring.JAXRSServerFactoryBeanDefinitionParser.SpringJAXRSServerFactoryBean;
import org.apache.cxf.transport.local.LocalConduit;
import org.jboss.weld.junit5.EnableWeld;
import org.jboss.weld.junit5.WeldInitiator;
import org.jboss.weld.junit5.WeldSetup;
import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInstance;
import org.junit.jupiter.api.TestInstance.Lifecycle;

import com.fasterxml.jackson.jaxrs.json.JacksonJaxbJsonProvider;

@TestInstance(Lifecycle.PER_CLASS)
@EnableWeld
public class AdminApiTest {
	
	@WeldSetup
	private WeldInitiator weld = WeldInitiator.from(WeldInitiator.createWeld()
			.addPackages(com.example.AdminApi.class, com.example.service.impl.AdminApiServiceImpl.class)
			.addBeanClasses(com.example.app.RestApplication.class)
			.addBeanClasses(TestConfiguration.class)
			.addExtension(new org.apache.cxf.cdi.JAXRSCdiResourceExtension()))
	.build();

	private com.example.AdminApi api;

	@BeforeAll
	public void setup() throws Exception {
		api = JAXRSClientFactory.create(TestConfiguration.ENDPOINT_ADDRESS, com.example.AdminApi.class, TestConfiguration.defaultProviders());
		WebClient.getConfig(api).getRequestContext().put(LocalConduit.DIRECT_DISPATCH, Boolean.TRUE);
	}
	
	@Test
	public void createAccountTest() {

		Response response = this.api.createAccount();
		Assertions.assertNotNull(response);
		com.example.model.AccountDetails result = response.readEntity(com.example.model.AccountDetails.class);
		Assertions.assertNotNull(result);
	}

	@Test
	public void getAccountsTest() {
		java.lang.String cursor = null;

		Response response = this.api.getAccounts(cursor);
		Assertions.assertNotNull(response);
		com.example.model.GetAccounts200Response result = response.readEntity(com.example.model.GetAccounts200Response.class);
		Assertions.assertNotNull(result);
	}

	@Test
	public void searchAccountsTest() {
		java.lang.String query = null;
		java.lang.String cursor = null;

		Response response = this.api.searchAccounts(query, cursor);
		Assertions.assertNotNull(response);
		com.example.model.SearchAccounts200Response result = response.readEntity(com.example.model.SearchAccounts200Response.class);
		Assertions.assertNotNull(result);
	}

}
