package com.example;

import java.util.ArrayList;

import javax.ws.rs.core.Response;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.spring.JAXRSServerFactoryBeanDefinitionParser.SpringJAXRSServerFactoryBean;
import org.apache.cxf.transport.local.LocalConduit;
import org.jboss.weld.junit5.EnableWeld;
import org.jboss.weld.junit5.WeldInitiator;
import org.jboss.weld.junit5.WeldSetup;
import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInstance;
import org.junit.jupiter.api.TestInstance.Lifecycle;

import com.fasterxml.jackson.jaxrs.json.JacksonJaxbJsonProvider;

@TestInstance(Lifecycle.PER_CLASS)
@EnableWeld
public class ParticipationsApiTest {
	
	@WeldSetup
	private WeldInitiator weld = WeldInitiator.from(WeldInitiator.createWeld()
			.addPackages(com.example.ParticipationsApi.class, com.example.service.impl.ParticipationsApiServiceImpl.class)
			.addBeanClasses(com.example.app.RestApplication.class)
			.addBeanClasses(TestConfiguration.class)
			.addExtension(new org.apache.cxf.cdi.JAXRSCdiResourceExtension()))
	.build();

	private com.example.ParticipationsApi api;

	@BeforeAll
	public void setup() throws Exception {
		api = JAXRSClientFactory.create(TestConfiguration.ENDPOINT_ADDRESS, com.example.ParticipationsApi.class, TestConfiguration.defaultProviders());
		WebClient.getConfig(api).getRequestContext().put(LocalConduit.DIRECT_DISPATCH, Boolean.TRUE);
	}
	
	@Test
	public void createParticipationTest() {
		java.lang.String surveyToken = null;
		java.lang.String emailAddress = null;

		Response response = this.api.createParticipation(surveyToken, emailAddress);
		Assertions.assertNotNull(response);
	}

	@Test
	public void findParticipationInfoTest() {
		java.lang.String token = null;

		Response response = this.api.findParticipationInfo(token);
		Assertions.assertNotNull(response);
		com.example.model.FindParticipationInfo200Response result = response.readEntity(com.example.model.FindParticipationInfo200Response.class);
		Assertions.assertNotNull(result);
	}

	@Test
	public void findSurveyByTokenTest() {
		java.lang.String surveyToken = null;

		Response response = this.api.findSurveyByToken(surveyToken);
		Assertions.assertNotNull(response);
		com.example.model.ParticipationSurvey result = response.readEntity(com.example.model.ParticipationSurvey.class);
		Assertions.assertNotNull(result);
	}

	@Test
	public void getParticipationSurveyTest() {
		java.util.UUID participationId = null;

		Response response = this.api.getParticipationSurvey(participationId);
		Assertions.assertNotNull(response);
		com.example.model.ParticipationSurvey result = response.readEntity(com.example.model.ParticipationSurvey.class);
		Assertions.assertNotNull(result);
	}

}
